/* 
 * AppController.m created by phr on 2000-08-27 11:38:58 +0000
 *
 * GNUstep Application Controller
 *
 * Created with ProjectCenter - http://www.gnustep.org
 *
 * $Id: AppController.m,v 1.1 2003/05/06 08:06:58 stoyan Exp $
 */


#include "AppController.h"
#include "DockTile.h"

@implementation AppController

static NSDictionary *infoDict = nil;

+ (void)initialize
{
  NSMutableDictionary *defaults = [NSMutableDictionary dictionary];

  /*
   * Register your app's defaults here by adding objects to the
   * dictionary, eg
   *
   * [defaults setObject:anObject forKey:keyForThatObject];
   *
   */
  
  [[NSUserDefaults standardUserDefaults] registerDefaults:defaults];
  [[NSUserDefaults standardUserDefaults] synchronize];
}

- (id)init
{
  if ((self = [super init])) {
  }
  return self;
}

- (void)dealloc
{
  [super dealloc];
}

- (void)awakeFromNib
{
}

- (void)applicationDidFinishLaunching:(NSNotification *)notif
{
    [self makeWindow];
    [self addLogoTile];
    [self addRecyclerTile];
    
    
    //START test code for adding icons
    NSInvocation *inv;

    inv = [NSInvocation 
              invocationWithMethodSignature: 
                  [self methodSignatureForSelector: 
                            @selector(tick)]];
    [inv setSelector:@selector(tick)];
    [inv setTarget:self];
    [inv retain];

    [NSTimer scheduledTimerWithTimeInterval:5.0
             invocation:inv
             repeats:YES];
    //DONE
}


- tick
{
    [self addTestTile];

    return self;
}


- (void)makeWindow
{
    NSRect rect;    
    rect = [[NSScreen mainScreen] frame];
    rect.origin.x = rect.size.width - 64;
    rect.origin.y = rect.size.height- 64;
    rect.size.width = 64;
    rect.size.height = 64;
    
    matrix = [[NSMatrix alloc] initWithFrame: rect 
	mode: NSTrackModeMatrix 
	cellClass: [DockTile class]
	numberOfRows: 0
	numberOfColumns: 0];
	
    [matrix setCellSize: NSMakeSize(64, 64)];

    //rect = [NSWindow frameRectForContentRect: rect
	//styleMask: NSBorderlessWindowMask];

    window = [[NSWindow alloc] initWithContentRect: rect
	styleMask: NSBorderlessWindowMask
	backing: NSBackingStoreRetained
	defer: YES];
	
    [window setTitle: @"GSDock"];

    [window setDelegate: self];

    //[window setFrame: rect
	//display: YES];

    [window setContentView: matrix];
    
    [window orderFrontRegardless];
    
    [window makeKeyWindow];    
    
}



- (DockTile*) insertTile:(int) number
{
    NSLog(@"insertTile");
    DockTile *tile;
    

    [matrix insertRow: number];

    tile = [matrix cellAtRow: number
	column: 0];

    [tile setImageFrameStyle: NSImageFrameButton];
    [tile setImageScaling: NSScaleProportionally];
    [tile setImageAlignment: NSImageAlignCenter];
    [self resizeDock];
    
    return tile;
}

- (void) resizeDock
{
    NSRect screenRect;
    NSRect frameRect;
    NSSize cellSize;

    //Has the dock grown to large?  Need to make the tiles smaller?
    screenRect = [[NSScreen mainScreen] frame];
    if( ([matrix numberOfRows] * 64) > screenRect.size.height) {
	NSLog(@"Dock needs to shrink");
	cellSize.height = (float)screenRect.size.height / (float)[matrix numberOfRows];
	cellSize.width = cellSize.height;	
    }
    else {
	cellSize.height = 64;
	cellSize.width = 64;
    }


    //resize and move the dock, centering it horizontally on the right edge of screen
    frameRect.origin.x = screenRect.size.width - cellSize.width;  
    if( cellSize.height == 64) {
	frameRect.origin.y = ((screenRect.size.height - (cellSize.height * [matrix numberOfRows])) / 2);
    }
    else {
	frameRect.origin.y = 0;
    }
    frameRect.size.width = cellSize.width;
    frameRect.size.height = cellSize.height * [matrix numberOfRows];

    [window setFrame: frameRect display:NO];
    [matrix setCellSize: cellSize];
    [matrix setNeedsDisplay: YES];
}
    
    
	
	
	

- (void)addLogoTile
{
    NSLog(@"addLogoTile");
    DockTile *tile;
    
    tile = [self insertTile: 0];
    
    [tile setImage: [NSImage imageNamed:@"DockLogo.tiff"]];
}

- (void)addRecyclerTile
{
    NSLog(@"addRecyclerTile");
    DockTile *tile;
    
    tile = [self insertTile: 1];
    
    [tile setImage: [NSImage imageNamed:@"Recycler.tiff"]];
}


- (void)addTestTile
{
    NSLog(@"addTestTile");
    DockTile *tile;
    
    tile = [self insertTile: [matrix numberOfRows]];
    
    [tile setImage: [NSImage imageNamed:@"RecyclerFull.tiff"]];
}    




- (BOOL)applicationShouldTerminate:(id)sender
{
  return YES;
}

- (void)applicationWillTerminate:(NSNotification *)notification
{
}

- (BOOL)application:(NSApplication *)application openFile:(NSString *)fileName
{
}

- (void)showPrefPanel:(id)sender
{
}

- (void)showInfoPanel:(id)sender
{
  [[NSApplication sharedApplication] orderFrontStandardInfoPanel:sender];
}

@end
